var dontSend = false;
var doSound = false;

function doSessionOnLoad() {
    this.onUsersChanged();
    if (typeof(window._MSG) != "undefined") { // From first incoming message
        var m = window._MSG;
        this.onMessageReceived(m[0], m[1], m[2], m[3]);
        delete window._MSG;
    }
    FontChanged();
    doTextSizeChange('small');
    document.getElementById('message').focus();
    this._OPENED = true; // flag for incoming session management
}

function doSessionOnUnLoad() {
    window._SESSION.exit();
    window.opener.client.unregisterSession(window._SESSION);
}

function doSendIM(e) {
    if ((e.type == 'command') || ((e.type == 'keypress' && e.keyCode == 13) && !e.shiftKey)) {
        var msgtext = window.document.getElementById('message').value;
        msgtext = msgtext.replace(/\n/g, '\r\n');
        if (msgtext == '') { return; }
        
        window.document.getElementById('message').value = '';
        var msg = createMessageContentNode(window.document, msgtext, window._SESSION._CLIENT.MMS);
        msg = createMessageNode(window.document, window._SESSION._CLIENT.Nickname, msg, true);
        appendAndScroll(window.document.getElementById('chat-panel').contentDocument, msg);
        e.preventBubble();

        if (window._SESSION.ContactsCount() == 1) {
            for (var c in window._SESSION.Contacts) {
                var con = window._SESSION.Contacts[c];
                if (typeof(con) == 'object')
                    if (con._GONE) {
                        window._SESSION._MSG = msgtext;
                        window._SESSION.invite(con.EMail);
                        return;
                    }
            }
            //msg = createNotifyNode(window.document, window._SESSION.bundle.GetStringFromName('noMembers'));
            //appendAndScroll(window.document.getElementById('chat-panel').contentDocument, msg);
        }
        window._SESSION.send(msgtext);
        return;
    }
    if (!dontSend) {
        if (window._SESSION.ContactsCount() == 0) {
            return;
        }
        dontSend = true;
        window._SESSION.sendTyping();
        setTimeout('dontSend = false', 4000);
    }
}

function doTextSizeChange(cls) {
    document.getElementById('chat-panel').contentDocument.body.setAttribute('class', cls);
    document.getElementById('message').setAttribute('class', cls);
}

window.openInvite =
function openInvite() {
    document.getElementById('info-box-splitter').setAttribute('state', "collapsed");
    var ib = document.getElementById('info-box');
    ib.width = '150px';
    // ADD TITLE
    var ibt = document.createElement('description');
    ibt.setAttribute('id', 'info-box-title');
    ibt.appendChild(document.createTextNode(window._SESSION.bundle.GetStringFromName('Invite')));
    ib.appendChild(ibt);
    // ADD ENTRY BOX
    var eb = document.createElement('vbox');
    eb.setAttribute('class', 'invite-box');
    eb.setAttribute('flex', '1');
    ib.appendChild(eb);
    // ADD ENTRIES
    var client = getMainWindow().client;
    for (var i in client.Contacts['FL']) {
        var con = client.Contacts['FL'][i];
        if (con.Status != 'FLN') {
            var add = true;
            for (var c in window._SESSION.Contacts) {
                if (window._SESSION.Contacts[c].EMail == con.EMail)
                    add = false;
            }
            if (add == true) {
                AddEntry(StatusImages[con.Status], con);
            }
        }
    }
 /*   // ADD UNKNOWN ENTRY
    var cp = document.createElement('hbox');
    cp.setAttribute('class', 'info-box-entry');    
    cp.appendChild(document.createElement('image'));
    cp.firstChild.setAttribute('src', 'chrome://msnmsgr/skin/msnmsgr-menu-icon.png');
    
    var tb = document.createElement('textbox');
    cp.appendChild(tb);
    
    ib.appendChild(cp); */
    // AND ADD CANCEL
    var cb = document.createElement('button');
    cb.setAttribute('label', window._SESSION.bundle.GetStringFromName('InviteCancel'));
    cb.setAttribute('oncommand', 'doInvite();');
    ib.appendChild(cb);

    document.getElementById('info-box-splitter').setAttribute('state', "open");

    function AddEntry (img, con) {
        var cp = document.createElement('hbox');
        cp.setAttribute('class', 'info-box-entry');
        cp.setAttribute('ondblclick', "doInvite('" + con.EMail + "')")
        
        cp.appendChild(document.createElement('image'));
        cp.firstChild.setAttribute('src', img);
        
        var cd = document.createElement('description');
        cd.setAttribute('value', con.Nickname);
        cd.setAttribute('tooltiptext', con.Nickname + '<' + con.EMail + '>');
        cd.setAttribute('flex', '1');
        cd.setAttribute('crop', 'end');
        
        cp.appendChild(cd);
        eb.appendChild(cp);
    }
}

function doInvite(contact) {
    if (contact) window._SESSION.invite(contact);
    document.getElementById('info-box-splitter').setAttribute('state', "collapsed");
    clearInfoBox();
}

function clearInfoBox() {
    var ib = document.getElementById('info-box');
    for (var i = ib.childNodes.length - 1; i >= 0; i--)
        ib.removeChild(ib.childNodes[i]);
}

window.onMessageReceived =
function onMessageReceived(from, fromEmail, headers, text) {
    if (headers['content-type'].substr(0, 10) == 'text/plain') {
        var textcontent = createMessageContentNode(window.document, text, headers['x-mms-im-format']);
        var msg = createMessageNode(window.document, from, textcontent);
        appendAndScroll(window.document.getElementById('chat-panel').contentDocument, msg);
        var con = null;
        con = window._SESSION.FindContact(fromEmail);
        con.timeout = 0;
        // beep when sending a message
        var sound = Components.classes["@mozilla.org/sound;1"].createInstance();
        if (sound) {
            sound.QueryInterface(Components.interfaces.nsISound);
            if (doSound == true) {
                sound.beep();
                window.getAttention();
            }
        }
        _updateSB();
    }
    else if (headers['content-type'].substr(0, 20) == 'text/x-msmsgscontrol') {
        var tu = headers['typinguser'];
        var con = null;
        con = window._SESSION.FindContact(tu);
        con.timeout = new Date().getTime();
        setTimeout('_updateSB()', 5000);
        _updateSB();
    }
    else if (headers['content-type'].substr(0, 19) == 'text/x-msmsgsinvite') {
        var h = new Array();
        var parts = text.split('\r\n');
        for (var i in parts) {
            var header = parts[i].split(": ");
            h[header[0]] = header[1];
        }

        if (h['Invitation-Command'] == 'INVITE')
            window._SESSION.cancelInvite(h['Invitation-Cookie'], "REJECT_NOT_INSTALLED");
        var msg = createNotifyNode(window.document, window._SESSION.bundle.GetStringFromName('InviteUnsupported'));
        appendAndScroll(window.document.getElementById('chat-panel').contentDocument, msg);
    }
}

window.onUsersChanged =
function onUsersChanged() {
    var value = '';
    for (var i in window._SESSION.Contacts) {
        var c = window._SESSION.Contacts[i];
        value += c.Nickname + ' <' + c.EMail + '>, ';
    }
    if (value == '') { value = window._SESSION.bundle.GetStringFromName('toNoOne') + '  ' };
    value = window._SESSION.bundle.GetStringFromName('sendMessageToLabel') + '  ' + value.substr(0, value.length - 2);
    var cp = window.document.getElementById('chat-participants')
    cp.firstChild.nodeValue = value;
}

window.FontChanged =
function FontChanged() {
    document.getElementById('message').setAttribute('style', window._SESSION._CLIENT.CSS);
}

function _updateSB() {
    var s = '';
    var count = 0;
    var t = new Date().getTime();
    for (var i in window._SESSION.Contacts) {
        var c = window._SESSION.Contacts[i];
        if (t <= c.timeout + 5000) {
            count++;
            s += c.Nickname + ', ';
        }
    }
    if (count == 0) {
        s = '';
    } else if (count == 1) {
        temp = window._SESSION.bundle.GetStringFromName('isTyping');
        s = temp.replace("%U", s.substr(0, s.length - 2));
    } else {
        temp = window._SESSION.bundle.GetStringFromName('areTyping');
        s = temp.replace("%U", s.substr(0, s.length - 2));
    }
    document.getElementById('status-bar-main').firstChild.setAttribute('label', s);
}